"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var Client_1 = require("../models/Client");
var DelugeTorrent_1 = require("./DelugeTorrent");
var ClientError_1 = require("../models/ClientError");
var DelugeClientRequest_1 = require("./DelugeClientRequest");
require('util.promisify/shim')();
var path = require("path");
var fs = require("fs");
var util = require("util");
var parseTorrent = require("parse-torrent");
var DelugeClient = (function (_super) {
    __extends(DelugeClient, _super);
    function DelugeClient() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    DelugeClient.prototype.connect = function () {
        return __awaiter(this, void 0, void 0, function () {
            var loginRequest, _a, _b, _c, req, _d, isConnected, hosts, host, timeout, request, state, id, status, connectRequest;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        if (this.opts.log)
                            this.opts.log('info', 'Trying to connect to deluged');
                        loginRequest = new DelugeClientRequest_1.default(this.opts);
                        _b = (_a = Object).assign;
                        _c = [this.opts];
                        return [4, loginRequest.login()];
                    case 1:
                        _b.apply(_a, _c.concat([_e.sent()]));
                        req = new DelugeClientRequest_1.default(this.opts);
                        req.add('isConnected', 'web.connected', []);
                        req.add('hosts', 'web.get_hosts', []);
                        return [4, req.send()];
                    case 2:
                        _d = _e.sent(), isConnected = _d.isConnected, hosts = _d.hosts;
                        if (isConnected) {
                            return [2];
                        }
                        if (!hosts.length) {
                            return [2, Promise.reject(new ClientError_1.default('offline_server', 'Cannot find a suitable deluge daemon'))];
                        }
                        timeout = util.promisify(setTimeout);
                        return [4, timeout(850)];
                    case 3:
                        _e.sent();
                        request = new DelugeClientRequest_1.default(this.opts);
                        request.add('state', 'web.get_host_status', [hosts[0][0]]);
                        return [4, request.send()];
                    case 4:
                        state = (_e.sent()).state;
                        id = state[0], status = state[3];
                        if (status === 'Online') {
                            host = id;
                        }
                        else {
                            return [2, Promise.reject(new ClientError_1.default('offline_server', 'Cannot find a suitable deluge daemon'))];
                        }
                        connectRequest = new DelugeClientRequest_1.default(this.opts);
                        connectRequest.add('omit', 'web.connect', [host]);
                        connectRequest.send();
                        return [2, this.connect()];
                }
            });
        });
    };
    DelugeClient.prototype.getTorrents = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var request, status;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        request = new DelugeClientRequest_1.default(this.opts);
                        request.add('status', 'web.update_ui', [[
                                'queue',
                                'name',
                                'total_wanted',
                                'state',
                                'progress',
                                'eta',
                                'download_payload_rate',
                                'upload_payload_rate'
                            ], {}]);
                        return [4, request.send()];
                    case 1:
                        status = (_a.sent()).status;
                        return [2, Object.keys(status.torrents).map(function (hash) {
                                var torrent = status.torrents[hash];
                                return new DelugeTorrent_1.default(_this.opts, hash, {
                                    name: torrent.name,
                                    eta: torrent.eta,
                                    downloadRate: status.download_payload_rate,
                                    uploadRate: status.upload_payload_rate
                                });
                            })];
                }
            });
        });
    };
    DelugeClient.prototype.addFiles = function (torrents, opts) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var request, res;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (opts.baseDirectory) {
                            throw new TypeError('Option `baseDirectory` is not supported in deluge');
                        }
                        request = new DelugeClientRequest_1.default(this.opts);
                        return [4, Promise.all(torrents.map(function (torrent, index) { return __awaiter(_this, void 0, void 0, function () {
                                var tmp, target, hash, writeFile, readFile, content;
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0:
                                            tmp = path.join(opts.tempDirectory || __dirname, Math.random().toString(36).substring(7) + '.torrent');
                                            target = Buffer.isBuffer(torrent) ? tmp : torrent;
                                            if (!Buffer.isBuffer(torrent)) return [3, 2];
                                            writeFile = util.promisify(fs.writeFile);
                                            return [4, writeFile(target, torrent)];
                                        case 1:
                                            _a.sent();
                                            hash = parseTorrent(torrent).infoHash;
                                            return [3, 4];
                                        case 2:
                                            readFile = util.promisify(fs.readFile);
                                            return [4, readFile(target, { encoding: null })];
                                        case 3:
                                            content = _a.sent();
                                            hash = parseTorrent(content).infoHash;
                                            _a.label = 4;
                                        case 4:
                                            request.add(hash || 'addFile_' + index, 'web.add_torrents', [[{
                                                        path: target,
                                                        options: {
                                                            download_location: opts.directory
                                                        }
                                                    }]]);
                                            return [2];
                                    }
                                });
                            }); }))];
                    case 1:
                        _a.sent();
                        return [4, request.send()];
                    case 2:
                        res = _a.sent();
                        return [2, Object.keys(res).map(function (hash) {
                                if (!res[hash])
                                    throw new ClientError_1.default('server_error', 'Unable to add file ' + hash);
                                return new DelugeTorrent_1.default(_this.opts, hash, {});
                            })];
                }
            });
        });
    };
    DelugeClient.prototype.addMagnet = function (torrent, opts) {
        throw new Error("Method not implemented.");
    };
    DelugeClient.prototype.getTorrent = function (hash) {
        return __awaiter(this, void 0, void 0, function () {
            var torrent;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        torrent = new DelugeTorrent_1.default(this.opts, hash, {});
                        return [4, torrent.update()];
                    case 1:
                        _a.sent();
                        return [2, torrent];
                }
            });
        });
    };
    return DelugeClient;
}(Client_1.default));
exports.default = DelugeClient;
//# sourceMappingURL=DelugeClient.js.map