"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var ClientRequest_1 = require("../models/ClientRequest");
var node_fetch_1 = require("node-fetch");
var set_cookie_parser_1 = require("set-cookie-parser");
var ClientError_1 = require("../models/ClientError");
var DelugeClientRequest = (function (_super) {
    __extends(DelugeClientRequest, _super);
    function DelugeClientRequest() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    DelugeClientRequest.prototype.login = function () {
        return __awaiter(this, void 0, void 0, function () {
            var res, result, cookie, err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 3, , 4]);
                        return [4, node_fetch_1.default("http://" + this.opts.host + ":" + this.opts.port + "/" + (this.opts.endpoint || 'json'), {
                                method: 'POST',
                                body: JSON.stringify({
                                    method: 'auth.login',
                                    params: [this.opts.password],
                                    id: 1
                                }),
                                headers: {
                                    'content-type': 'application/json'
                                }
                            })];
                    case 1:
                        res = _a.sent();
                        if (res.status !== 200) {
                            if (res.status === 500)
                                return [2, Promise.reject(new ClientError_1.default('server_error', 'unexpected server 500 error'))];
                            throw new ClientError_1.default('unknown_error', 'An unknown error occured');
                        }
                        return [4, res.json()];
                    case 2:
                        result = (_a.sent()).result;
                        if (!result) {
                            return [2, Promise.reject(new ClientError_1.default('wrong_credentials', 'Incorrect password'))];
                        }
                        cookie = set_cookie_parser_1.parse(res.headers.get('set-cookie'))[0].value;
                        return [2, { cookie: cookie }];
                    case 3:
                        err_1 = _a.sent();
                        if (err_1.code === 'ENOTFOUND') {
                            throw new ClientError_1.default('offline_server', 'Cannot reach server: ' + err_1.code);
                        }
                        throw new ClientError_1.default('unknown_error', 'An unknown error occured');
                    case 4: return [2];
                }
            });
        });
    };
    DelugeClientRequest.prototype.getRequest = function (id, method, params) {
        return { id: id, method: method, params: params };
    };
    DelugeClientRequest.prototype.send = function () {
        var _this = this;
        var requests = this.requests.map(function (req, index) {
            return function (results) { return __awaiter(_this, void 0, void 0, function () {
                var res, body, result, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            if (this.opts.log)
                                this.opts.log('trace', "POST http://" + this.opts.host + ":" + this.opts.port + "/" + (this.opts.endpoint || 'json') + " " + req.method, req);
                            return [4, node_fetch_1.default("http://" + this.opts.host + ":" + this.opts.port + "/" + (this.opts.endpoint || 'json'), {
                                    method: 'POST',
                                    body: JSON.stringify(__assign({}, req, { id: index })),
                                    headers: {
                                        'content-type': 'application/json',
                                        'cookie': "_session_id=" + this.opts.cookie
                                    }
                                })];
                        case 1:
                            res = _b.sent();
                            if (res.status !== 200) {
                                if (res.status === 500)
                                    return [2, Promise.reject(new ClientError_1.default('server_error', 'unexpected server 500 error'))];
                                throw new ClientError_1.default('unknown_error', 'An unknown error occured');
                            }
                            return [4, res.text()];
                        case 2:
                            body = _b.sent();
                            if (this.opts.log)
                                this.opts.log('trace', body);
                            result = JSON.parse(body).result;
                            Object.assign(results, (_a = {}, _a[req.id] = result, _a));
                            return [2];
                    }
                });
            }); };
        });
        var results = {};
        return requests.reduce(function (acc, val) {
            return acc.then(function () {
                return val(results);
            });
        }, Promise.resolve()).then(function () {
            return results;
        });
    };
    return DelugeClientRequest;
}(ClientRequest_1.default));
exports.default = DelugeClientRequest;
//# sourceMappingURL=DelugeClientRequest.js.map