"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var Torrent_1 = require("../models/Torrent");
var DelugeClientRequest_1 = require("./DelugeClientRequest");
var ClientError_1 = require("../models/ClientError");
var diff = require("deep-diff");
exports.statusMap = {
    'Seeding': 'seeding',
    'Downloading': 'downloading',
    'Paused': 'paused'
};
function mapResultToProps(res) {
    return {
        name: res.name,
        size: res.total_wanted,
        status: exports.statusMap[res.state],
        progress: res.progress / 100,
        eta: res.eta,
        downloadRate: res.download_payload_rate,
        uploadRate: res.upload_payload_rate
    };
}
exports.mapResultToProps = mapResultToProps;
var DelugeTorrent = (function (_super) {
    __extends(DelugeTorrent, _super);
    function DelugeTorrent(opts, hash, props) {
        return _super.call(this, opts, hash, props) || this;
    }
    DelugeTorrent.prototype.liveFeed = function (polling) {
        var _this = this;
        if (polling === void 0) { polling = 420; }
        if (polling < 1) {
            clearInterval(this.interval);
            this.live = false;
            return;
        }
        if (this.live)
            return;
        this.live = true;
        this.interval = setInterval(function () { return __awaiter(_this, void 0, void 0, function () {
            var _this = this;
            var req, props, newProps, delta;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        req = new DelugeClientRequest_1.default(this.opts);
                        req.add('props', 'web.get_torrent_status', [
                            this._hash, [
                                'queue',
                                'name',
                                'total_wanted',
                                'state',
                                'progress',
                                'eta',
                                'download_payload_rate',
                                'upload_payload_rate'
                            ]
                        ]);
                        return [4, req.send()];
                    case 1:
                        props = (_a.sent()).props;
                        newProps = mapResultToProps(props);
                        if (Object.keys(props).length === 0) {
                            this.emit('remove');
                            clearInterval(this.interval);
                            this.live = false;
                            return [2];
                        }
                        delta = diff.diff(newProps, this.props);
                        this.props = newProps;
                        if (delta) {
                            delta.forEach(function (_a) {
                                var kind = _a.kind, key = _a.path[0], value = _a.lhs, old = _a.rhs;
                                if (key === 'progress') {
                                    _this.emit('progress', value);
                                }
                                if (key === 'status') {
                                    if (value === 'seeding' && old === 'downloading')
                                        _this.emit('finish');
                                    if (value === 'paused' && old !== 'stopped')
                                        _this.emit('pause');
                                    if (value === 'downloading' && old === 'paused')
                                        _this.emit('resume');
                                    if (value === 'stopped' && old !== 'finish')
                                        _this.emit('stop');
                                }
                            });
                        }
                        return [2];
                }
            });
        }); }, polling);
    };
    DelugeTorrent.prototype.update = function () {
        return __awaiter(this, void 0, void 0, function () {
            var req, props, newProps;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        req = new DelugeClientRequest_1.default(this.opts);
                        req.add('props', 'web.get_torrent_status', [
                            this._hash, [
                                'queue',
                                'name',
                                'total_wanted',
                                'state',
                                'progress',
                                'eta',
                                'download_payload_rate',
                                'upload_payload_rate'
                            ]
                        ]);
                        return [4, req.send()];
                    case 1:
                        props = (_a.sent()).props;
                        newProps = mapResultToProps(props);
                        this.props = newProps;
                        return [2];
                }
            });
        });
    };
    DelugeTorrent.prototype.pause = function () {
        return __awaiter(this, void 0, void 0, function () {
            var req;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        req = new DelugeClientRequest_1.default(this.opts);
                        req.add('paused', 'core.pause_torrent', [[this._hash]]);
                        return [4, req.send()];
                    case 1:
                        _a.sent();
                        return [2];
                }
            });
        });
    };
    DelugeTorrent.prototype.resume = function () {
        return __awaiter(this, void 0, void 0, function () {
            var req;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        req = new DelugeClientRequest_1.default(this.opts);
                        req.add('paused', 'core.resume_torrent', [[this._hash]]);
                        return [4, req.send()];
                    case 1:
                        _a.sent();
                        return [2];
                }
            });
        });
    };
    DelugeTorrent.prototype.remove = function (deleteData) {
        return __awaiter(this, void 0, void 0, function () {
            var req, deleted;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        req = new DelugeClientRequest_1.default(this.opts);
                        req.add('deleted', 'core.remove_torrent', [this._hash, deleteData]);
                        return [4, req.send()];
                    case 1:
                        deleted = (_a.sent()).deleted;
                        if (!deleted) {
                            throw new ClientError_1.default('server_error', 'Unable to delete torrent');
                        }
                        return [2];
                }
            });
        });
    };
    return DelugeTorrent;
}(Torrent_1.default));
exports.default = DelugeTorrent;
//# sourceMappingURL=DelugeTorrent.js.map