/// <reference types="node" />
import Torrent from './Torrent';
export interface AddTorrentOptions {
    directory: string;
    baseDirectory?: boolean;
    tempDirectory?: string;
}
export default abstract class Client<T> {
    protected opts: any;
    constructor(opts: T);
    abstract connect(): Promise<void>;
    abstract getTorrents(): Promise<Torrent<T>[]>;
    addFile(torrent: (string | Buffer), opts: AddTorrentOptions): Promise<Torrent<T>>;
    abstract addFiles(torrent: (string | Buffer)[], opts: AddTorrentOptions): Promise<Torrent<T>[]>;
    abstract addMagnet(torrent: string, opts: AddTorrentOptions): Promise<Torrent<T>>;
    abstract getTorrent(hash: string): Promise<Torrent<T>>;
}
