export interface ClientRequestOptions {
    id: string;
}
export interface ClientResponse {
    [id: string]: any;
}
export default abstract class ClientRequest<T, R extends ClientRequestOptions, K> {
    protected requests: R[];
    protected opts: Partial<T & K>;
    constructor(opts: Partial<T & K>);
    abstract login(): Promise<K>;
    abstract getRequest(id: string, method: string, args: any[]): R;
    addRequest(request: R): this;
    add(id: string, method: string, args: any[]): void;
    abstract send(): Promise<ClientResponse>;
}
